Index: drivers/filesystems/btrfs/fileinfo.c
===================================================================
--- drivers/filesystems/btrfs/fileinfo.c	(révision 74430)
+++ drivers/filesystems/btrfs/fileinfo.c	(copie de travail)
@@ -1897,11 +1553,24 @@
         
         // add to new parent
         ExAcquireResourceExclusiveLite(&related->fcb->nonpaged->dir_children_lock, TRUE);
+        
+        if (IsListEmpty(&related->fcb->dir_children_index))
+            fileref->dc->index = 2;
+        else {
+            dir_child* dc2 = CONTAINING_RECORD(related->fcb->dir_children_index.Blink, dir_child, list_entry_index);
+            
+            fileref->dc->index = max(2, dc2->index + 1);
+        }
+        
         InsertTailList(&related->fcb->dir_children_index, &fileref->dc->list_entry_index);
         insert_dir_child_into_hash_lists(related->fcb, fileref->dc);
         ExReleaseResourceLite(&related->fcb->nonpaged->dir_children_lock);
     }
     
+    ExAcquireResourceExclusiveLite(&related->nonpaged->children_lock, TRUE);
+    InsertTailList(&related->children, &fileref->list_entry);
+    ExReleaseResourceLite(&related->nonpaged->children_lock);
+    
     if (fcb->inode_item.st_nlink > 1) {
         // add new hardlink entry to fcb
         
@@ -1913,9 +1582,9 @@
         }
         
         hl->parent = related->fcb->inode;
-        hl->index = index;
+        hl->index = fileref->dc->index;
         
-        hl->name.Length = hl->name.MaximumLength = fileref->filepart.Length;
+        hl->name.Length = hl->name.MaximumLength = fnus.Length;
         hl->name.Buffer = ExAllocatePoolWithTag(PagedPool, hl->name.MaximumLength, ALLOC_TAG);
         
         if (!hl->name.Buffer) {
@@ -1925,9 +1594,9 @@
             goto end;
         }
         
-        RtlCopyMemory(hl->name.Buffer, fileref->filepart.Buffer, fileref->filepart.Length);
+        RtlCopyMemory(hl->name.Buffer, fnus.Buffer, fnus.Length);
         
-        hl->utf8.Length = hl->utf8.MaximumLength = fileref->utf8.Length;
+        hl->utf8.Length = hl->utf8.MaximumLength = fileref->dc->utf8.Length;
         hl->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, hl->utf8.MaximumLength, ALLOC_TAG);
         
         if (!hl->utf8.Buffer) {
@@ -1938,7 +1607,7 @@
             goto end;
         }
         
-        RtlCopyMemory(hl->utf8.Buffer, fileref->utf8.Buffer, fileref->utf8.Length);
+        RtlCopyMemory(hl->utf8.Buffer, fileref->dc->utf8.Buffer, fileref->dc->utf8.Length);
         
         InsertTailList(&fcb->hardlinks, &hl->list_entry);
     }
@@ -1949,7 +1618,7 @@
     while (le != &fcb->hardlinks) {
         hl = CONTAINING_RECORD(le, hardlink, list_entry);
         
-        if (hl->parent == fr2->parent->fcb->inode && hl->index == fr2->index) {
+        if (hl->parent == fr2->parent->fcb->inode && hl->index == fr2->oldindex) {
             RemoveEntryList(&hl->list_entry);
             
             if (hl->utf8.Buffer)
@@ -1970,15 +1639,17 @@
     KeQuerySystemTime(&time);
     win_time_to_unix(time, &now);
     
-    fcb->inode_item.transid = Vcb->superblock.generation;
-    fcb->inode_item.sequence++;
+    if (fileref->parent->fcb->subvol == fcb->subvol || !(fcb->subvol->root_item.flags & BTRFS_SUBVOL_READONLY)) {
+        fcb->inode_item.transid = Vcb->superblock.generation;
+        fcb->inode_item.sequence++;
+        
+        if (!ccb->user_set_change_time)
+            fcb->inode_item.st_ctime = now;
+        
+        fcb->inode_item_changed = TRUE;
+        mark_fcb_dirty(fcb);
+    }
     
-    if (!ccb->user_set_change_time)
-        fcb->inode_item.st_ctime = now;
-    
-    fcb->inode_item_changed = TRUE;
-    mark_fcb_dirty(fcb);
-    
     // update new parent's INODE_ITEM
     
     related->fcb->inode_item.transid = Vcb->superblock.generation;
@@ -1996,18 +1667,17 @@
     
     fr2->parent->fcb->inode_item.transid = Vcb->superblock.generation;
     TRACE("fr2->parent->fcb->inode_item.st_size (inode %llx) was %llx\n", fr2->parent->fcb->inode, fr2->parent->fcb->inode_item.st_size);
-    fr2->parent->fcb->inode_item.st_size -= 2 * fr2->utf8.Length;
+    fr2->parent->fcb->inode_item.st_size -= 2 * origutf8len;
     TRACE("fr2->parent->fcb->inode_item.st_size (inode %llx) now %llx\n", fr2->parent->fcb->inode, fr2->parent->fcb->inode_item.st_size);
     fr2->parent->fcb->inode_item.sequence++;
     fr2->parent->fcb->inode_item.st_ctime = now;
     fr2->parent->fcb->inode_item.st_mtime = now;
     
-    free_fileref(fr2);
+    free_fileref(Vcb, fr2);
     
     fr2->parent->fcb->inode_item_changed = TRUE;
     mark_fcb_dirty(fr2->parent->fcb);
     
-    send_notification_fileref(fr2, fcb->type == BTRFS_TYPE_DIRECTORY ? FILE_NOTIFY_CHANGE_DIR_NAME : FILE_NOTIFY_CHANGE_FILE_NAME, FILE_ACTION_REMOVED);
     send_notification_fileref(fileref, fcb->type == BTRFS_TYPE_DIRECTORY ? FILE_NOTIFY_CHANGE_DIR_NAME : FILE_NOTIFY_CHANGE_FILE_NAME, FILE_ACTION_ADDED);
     send_notification_fileref(related, FILE_NOTIFY_CHANGE_LAST_WRITE, FILE_ACTION_MODIFIED);
     send_notification_fileref(fr2->parent, FILE_NOTIFY_CHANGE_LAST_WRITE, FILE_ACTION_MODIFIED);
@@ -2016,16 +1686,16 @@
 
 end:
     if (oldfileref)
-        free_fileref(oldfileref);
+        free_fileref(Vcb, oldfileref);
     
     if (!NT_SUCCESS(Status) && related)
-        free_fileref(related);
+        free_fileref(Vcb, related);
     
     if (!NT_SUCCESS(Status) && fr2)
-        free_fileref(fr2);
+        free_fileref(Vcb, fr2);
     
     if (NT_SUCCESS(Status))
-        clear_rollback(Vcb, &rollback);
+        clear_rollback(&rollback);
     else
         do_rollback(Vcb, &rollback);
 
@@ -2036,7 +1706,7 @@
     return Status;
 }
 
-NTSTATUS STDCALL stream_set_end_of_file_information(device_extension* Vcb, UINT64 end, fcb* fcb, file_ref* fileref, PFILE_OBJECT FileObject, BOOL advance_only, LIST_ENTRY* rollback) {
+NTSTATUS STDCALL stream_set_end_of_file_information(device_extension* Vcb, UINT64 end, fcb* fcb, file_ref* fileref, PFILE_OBJECT FileObject, BOOL advance_only) {
     LARGE_INTEGER time;
     BTRFS_TIME now;
     CC_FILE_SIZES ccfs;
@@ -2143,7 +1813,7 @@
     }
     
     if (fcb->ads) {
-        Status = stream_set_end_of_file_information(Vcb, feofi->EndOfFile.QuadPart, fcb, fileref, FileObject, advance_only, &rollback);
+        Status = stream_set_end_of_file_information(Vcb, feofi->EndOfFile.QuadPart, fcb, fileref, FileObject, advance_only);
         goto end;
     }
     
@@ -2210,7 +1880,7 @@
 
 end:
     if (NT_SUCCESS(Status))
-        clear_rollback(Vcb, &rollback);
+        clear_rollback(&rollback);
     else
         do_rollback(Vcb, &rollback);
 
@@ -2224,18 +1894,7 @@
     return Status;
 }
 
-// static NTSTATUS STDCALL set_allocation_information(device_extension* Vcb, PIRP Irp, PFILE_OBJECT FileObject) {
-//     FILE_ALLOCATION_INFORMATION* fai = (FILE_ALLOCATION_INFORMATION*)Irp->AssociatedIrp.SystemBuffer;
-//     fcb* fcb = FileObject->FsContext;
-//     
-//     FIXME("FIXME\n");
-//     ERR("fcb = %p (%.*S)\n", fcb, fcb->full_filename.Length / sizeof(WCHAR), fcb->full_filename.Buffer);
-//     ERR("AllocationSize = %llx\n", fai->AllocationSize.QuadPart);
-//     
-//     return STATUS_NOT_IMPLEMENTED;
-// }
-
-static NTSTATUS STDCALL set_position_information(device_extension* Vcb, PIRP Irp, PFILE_OBJECT FileObject) {
+static NTSTATUS STDCALL set_position_information(PFILE_OBJECT FileObject, PIRP Irp) {
     FILE_POSITION_INFORMATION* fpi = (FILE_POSITION_INFORMATION*)Irp->AssociatedIrp.SystemBuffer;
     
     TRACE("setting the position on %S to %llx\n", file_desc(FileObject), fpi->CurrentByteOffset.QuadPart);
@@ -2252,7 +1911,6 @@
     fcb *fcb = FileObject->FsContext, *tfofcb, *parfcb;
     ccb* ccb = FileObject->FsContext2;
     file_ref *fileref = ccb ? ccb->fileref : NULL, *oldfileref = NULL, *related = NULL, *fr2 = NULL;
-    UINT64 index;
     WCHAR* fn;
     ULONG fnlen, utf8len;
     UNICODE_STRING fnus;
@@ -2376,7 +2034,7 @@
                 goto end;
             }
         } else {
-            free_fileref(oldfileref);
+            free_fileref(Vcb, oldfileref);
             oldfileref = NULL;
         }
     }
@@ -2395,7 +2053,7 @@
     if (!SeAccessCheck(related->fcb->sd, &subjcont, FALSE, FILE_ADD_FILE, 0, NULL,
                        IoGetFileObjectGenericMapping(), Irp->RequestorMode, &access, &Status)) {
         SeReleaseSubjectContext(&subjcont);
-        WARN("SeAccessCheck failed, returning %08x\n", Status);
+        TRACE("SeAccessCheck failed, returning %08x\n", Status);
         goto end;
     }
 
@@ -2413,7 +2071,7 @@
         if (!SeAccessCheck(oldfileref->fcb->sd, &subjcont, FALSE, DELETE, 0, NULL,
                            IoGetFileObjectGenericMapping(), Irp->RequestorMode, &access, &Status)) {
             SeReleaseSubjectContext(&subjcont);
-            WARN("SeAccessCheck failed, returning %08x\n", Status);
+            TRACE("SeAccessCheck failed, returning %08x\n", Status);
             goto end;
         }
 
@@ -2426,46 +2084,24 @@
         }
     }
     
-    Status = fcb_get_last_dir_index(related->fcb, &index, Irp);
-    if (!NT_SUCCESS(Status)) {
-        ERR("fcb_get_last_dir_index returned %08x\n", Status);
-        goto end;
-    }
+    fr2 = create_fileref(Vcb);
     
-    fr2 = create_fileref();
-    
     fr2->fcb = fcb;
     fcb->refcount++;
     
-    fr2->utf8 = utf8;
-    fr2->index = index;
     fr2->created = TRUE;
     fr2->parent = related;
-    
-    fr2->filepart.Buffer = ExAllocatePoolWithTag(PagedPool, fnus.Length, ALLOC_TAG);
-    if (!fr2->filepart.Buffer) {
-        ERR("out of memory\n");
-        Status = STATUS_INSUFFICIENT_RESOURCES;
-        goto end;
-    }
-    
-    fr2->filepart.Length = fr2->filepart.MaximumLength = fnus.Length;
-    RtlCopyMemory(fr2->filepart.Buffer, fnus.Buffer, fnus.Length);
-    
-    Status = RtlUpcaseUnicodeString(&fr2->filepart_uc, &fr2->filepart, TRUE);
-    if (!NT_SUCCESS(Status)) {
-        ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
-        goto end;
-    }
-      
-    insert_fileref_child(related, fr2, TRUE);
-    
-    Status = add_dir_child(related->fcb, fcb->inode, FALSE, index, &utf8, &fr2->filepart, &fr2->filepart_uc, fcb->type, &dc);
+
+    Status = add_dir_child(related->fcb, fcb->inode, FALSE, &utf8, &fnus, fcb->type, &dc);
     if (!NT_SUCCESS(Status))
         WARN("add_dir_child returned %08x\n", Status);
     
     fr2->dc = dc;
     dc->fileref = fr2;
+    
+    ExAcquireResourceExclusiveLite(&related->nonpaged->children_lock, TRUE);
+    InsertTailList(&related->children, &fr2->list_entry);
+    ExReleaseResourceLite(&related->nonpaged->children_lock);
 
     // add hardlink for existing fileref, if it's not there already
     if (IsListEmpty(&fcb->hardlinks)) {
@@ -2477,10 +2113,10 @@
         }
         
         hl->parent = fileref->parent->fcb->inode;
-        hl->index = fileref->index;
+        hl->index = fileref->dc->index;
         
-        hl->name.Length = hl->name.MaximumLength = fileref->filepart.Length;
-        hl->name.Buffer = ExAllocatePoolWithTag(PagedPool, hl->name.MaximumLength, ALLOC_TAG);
+        hl->name.Length = hl->name.MaximumLength = fnus.Length;
+        hl->name.Buffer = ExAllocatePoolWithTag(PagedPool, fnus.Length, ALLOC_TAG);
         
         if (!hl->name.Buffer) {
             ERR("out of memory\n");
@@ -2489,9 +2125,9 @@
             goto end;
         }
         
-        RtlCopyMemory(hl->name.Buffer, fileref->filepart.Buffer, fileref->filepart.Length);
+        RtlCopyMemory(hl->name.Buffer, fnus.Buffer, fnus.Length);
         
-        hl->utf8.Length = hl->utf8.MaximumLength = fileref->utf8.Length;
+        hl->utf8.Length = hl->utf8.MaximumLength = fileref->dc->utf8.Length;
         hl->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, hl->utf8.MaximumLength, ALLOC_TAG);
         
         if (!hl->utf8.Buffer) {
@@ -2502,7 +2138,7 @@
             goto end;
         }
         
-        RtlCopyMemory(hl->utf8.Buffer, fileref->utf8.Buffer, fileref->utf8.Length);
+        RtlCopyMemory(hl->utf8.Buffer, fileref->dc->utf8.Buffer, fileref->dc->utf8.Length);
         
         InsertTailList(&fcb->hardlinks, &hl->list_entry);
     }
@@ -2515,7 +2151,7 @@
     }
     
     hl->parent = related->fcb->inode;
-    hl->index = index;
+    hl->index = dc->index;
     
     hl->name.Length = hl->name.MaximumLength = fnus.Length;
     hl->name.Buffer = ExAllocatePoolWithTag(PagedPool, hl->name.MaximumLength, ALLOC_TAG);
@@ -2541,11 +2177,12 @@
     }
     
     RtlCopyMemory(hl->utf8.Buffer, utf8.Buffer, utf8.Length);
+    ExFreePool(utf8.Buffer);
     
     InsertTailList(&fcb->hardlinks, &hl->list_entry);
     
     mark_fileref_dirty(fr2);
-    free_fileref(fr2);
+    free_fileref(Vcb, fr2);
     
     // update inode's INODE_ITEM
     
@@ -2580,16 +2217,16 @@
     
 end:
     if (oldfileref)
-        free_fileref(oldfileref);
+        free_fileref(Vcb, oldfileref);
     
     if (!NT_SUCCESS(Status) && related)
-        free_fileref(related);
+        free_fileref(Vcb, related);
     
     if (!NT_SUCCESS(Status) && fr2)
-        free_fileref(fr2);
+        free_fileref(Vcb, fr2);
     
     if (NT_SUCCESS(Status))
-        clear_rollback(Vcb, &rollback);
+        clear_rollback(&rollback);
     else
         do_rollback(Vcb, &rollback);
 
@@ -2612,9 +2249,12 @@
     
     top_level = is_top_level(Irp);
     
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
-        goto exit;
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_set_information(DeviceObject, Irp);
+        goto end;
+    } else if (!Vcb || Vcb->type != VCB_TYPE_FS) {
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
     }
     
     if (!(Vcb->Vpb->Flags & VPB_MOUNTED)) {
@@ -2640,7 +2280,7 @@
     }
     
     if (fcb->subvol->root_item.flags & BTRFS_SUBVOL_READONLY && IrpSp->Parameters.SetFile.FileInformationClass != FilePositionInformation &&
-        (fcb->inode != SUBVOL_ROOT_INODE || IrpSp->Parameters.SetFile.FileInformationClass != FileBasicInformation)) {
+        (fcb->inode != SUBVOL_ROOT_INODE || (IrpSp->Parameters.SetFile.FileInformationClass != FileBasicInformation && IrpSp->Parameters.SetFile.FileInformationClass != FileRenameInformation))) {
         Status = STATUS_ACCESS_DENIED;
         goto end;
     }
@@ -2720,7 +2360,7 @@
         {
             TRACE("FilePositionInformation\n");
             
-            Status = set_position_information(Vcb, Irp, IrpSp->FileObject);
+            Status = set_position_information(IrpSp->FileObject, Irp);
             
             break;
         }
@@ -2760,7 +2400,6 @@
 
     IoCompleteRequest(Irp, IO_NO_INCREMENT);
     
-exit:
     if (top_level) 
         IoSetTopLevelIrp(NULL);
     
@@ -2843,7 +2482,7 @@
         
         fsi->AllocationSize.QuadPart = fsi->EndOfFile.QuadPart = fcb->adsdata.Length;
         fsi->NumberOfLinks = fileref->parent->fcb->inode_item.st_nlink;
-        fsi->Directory = S_ISDIR(fileref->parent->fcb->inode_item.st_mode);
+        fsi->Directory = FALSE;
     } else {
         fsi->AllocationSize.QuadPart = S_ISDIR(fcb->inode_item.st_mode) ? 0 : sector_align(fcb->inode_item.st_size, fcb->Vcb->superblock.sector_size);
         fsi->EndOfFile.QuadPart = S_ISDIR(fcb->inode_item.st_mode) ? 0 : fcb->inode_item.st_size;
@@ -2884,7 +2523,7 @@
     
     fai->AccessFlags = GENERIC_READ;
     
-    return STATUS_NOT_IMPLEMENTED;
+    return STATUS_NOT_IMPLEMENTED; // FIXME
 }
 
 static NTSTATUS STDCALL fill_in_file_position_information(FILE_POSITION_INFORMATION* fpi, PFILE_OBJECT FileObject, LONG* length) {
@@ -2933,100 +2572,85 @@
     return STATUS_SUCCESS;
 }
 
-typedef struct {
-    file_ref* fileref;
-    LIST_ENTRY list_entry;
-} fileref_list;
-
-NTSTATUS fileref_get_filename(file_ref* fileref, PUNICODE_STRING fn, USHORT* name_offset) {
-    LIST_ENTRY fr_list, *le;
+NTSTATUS fileref_get_filename(file_ref* fileref, PUNICODE_STRING fn, USHORT* name_offset, ULONG* preqlen) {
     file_ref* fr;
     NTSTATUS Status;
-    ULONG len, i;
+    ULONG reqlen = 0;
+    USHORT offset;
+    BOOL overflow = FALSE;
     
     // FIXME - we need a lock on filerefs' filepart
     
     if (fileref == fileref->fcb->Vcb->root_fileref) {
-        fn->Buffer = ExAllocatePoolWithTag(PagedPool, sizeof(WCHAR), ALLOC_TAG);
-        if (!fn->Buffer) {
-            ERR("out of memory\n");
-            return STATUS_INSUFFICIENT_RESOURCES;
+        if (fn->MaximumLength >= sizeof(WCHAR)) {
+            fn->Buffer[0] = '\\';
+            fn->Length = sizeof(WCHAR);
+            
+            if (name_offset)
+                *name_offset = 0;
+            
+            return STATUS_SUCCESS;
+        } else {
+            if (preqlen)
+                *preqlen = sizeof(WCHAR);
+            fn->Length = 0;
+            
+            return STATUS_BUFFER_OVERFLOW;
         }
-        
-        fn->Length = fn->MaximumLength = sizeof(WCHAR);
-        fn->Buffer[0] = '\\';
-
-        if (name_offset)
-            *name_offset = 0;
-
-        return STATUS_SUCCESS;
     }
     
-    InitializeListHead(&fr_list);
-    
-    len = 0;
     fr = fileref;
+    offset = 0;
     
-    do {
-        fileref_list* frl;
+    while (fr->parent) {
+        USHORT movelen;
         
-        frl = ExAllocatePoolWithTag(PagedPool, sizeof(fileref_list), ALLOC_TAG);
-        if (!frl) {
-            ERR("out of memory\n");
-            Status = STATUS_INSUFFICIENT_RESOURCES;
-            goto end;
+        if (!overflow) {
+            if (fr->dc->name.Length + sizeof(WCHAR) > fn->MaximumLength - fn->Length)
+                overflow = TRUE;
         }
         
-        frl->fileref = fr;
-        InsertTailList(&fr_list, &frl->list_entry);
+        if (overflow)
+            movelen = fn->MaximumLength - fr->dc->name.Length - sizeof(WCHAR);
+        else
+            movelen = fn->Length;
         
-        len += fr->filepart.Length;
+        if ((!overflow || fn->MaximumLength > fr->dc->name.Length + sizeof(WCHAR)) && movelen > 0) {
+            RtlMoveMemory(&fn->Buffer[(fr->dc->name.Length / sizeof(WCHAR)) + 1], fn->Buffer, movelen);
+            offset += fr->dc->name.Length + sizeof(WCHAR);
+        }
         
-        if (fr != fileref->fcb->Vcb->root_fileref)
-            len += sizeof(WCHAR);
-        
-        fr = fr->parent;
-    } while (fr);
-    
-    fn->Buffer = ExAllocatePoolWithTag(PagedPool, len, ALLOC_TAG);
-    if (!fn->Buffer) {
-        ERR("out of memory\n");
-        Status = STATUS_INSUFFICIENT_RESOURCES;
-        goto end;
-    }
-    
-    fn->Length = fn->MaximumLength = len;
-    
-    i = 0;
-    
-    le = fr_list.Blink;
-    while (le != &fr_list) {
-        fileref_list* frl = CONTAINING_RECORD(le, fileref_list, list_entry);
-        
-        if (frl->fileref != fileref->fcb->Vcb->root_fileref) {
-            fn->Buffer[i] = frl->fileref->fcb->ads ? ':' : '\\';
-            i++;
+        if (fn->MaximumLength >= sizeof(WCHAR)) {
+            fn->Buffer[0] = fr->fcb->ads ? ':' : '\\';
+            fn->Length += sizeof(WCHAR);
             
-            if (name_offset && frl->fileref == fileref)
-                *name_offset = i * sizeof(WCHAR);
+            if (fn->MaximumLength > sizeof(WCHAR)) {
+                RtlCopyMemory(&fn->Buffer[1], fr->dc->name.Buffer, min(fr->dc->name.Length, fn->MaximumLength - sizeof(WCHAR)));
+                fn->Length += fr->dc->name.Length;
+            }
             
-            RtlCopyMemory(&fn->Buffer[i], frl->fileref->filepart.Buffer, frl->fileref->filepart.Length);
-            i += frl->fileref->filepart.Length / sizeof(WCHAR);
+            if (fn->Length > fn->MaximumLength) {
+                fn->Length = fn->MaximumLength;
+                overflow = TRUE;
+            }
         }
+         
+        reqlen += sizeof(WCHAR) + fr->dc->name.Length;
         
-        le = le->Blink;
+        fr = fr->parent;
     }
     
-    Status = STATUS_SUCCESS;
-    
-end:
-    while (!IsListEmpty(&fr_list)) {
-        fileref_list* frl;
+    offset += sizeof(WCHAR);
+
+    if (overflow) {
+        if (preqlen)
+            *preqlen = reqlen;
+        Status = STATUS_BUFFER_OVERFLOW;
+    } else {
+        if (name_offset)
+            *name_offset = offset;
         
-        le = RemoveHeadList(&fr_list);
-        frl = CONTAINING_RECORD(le, fileref_list, list_entry);
-        
-        ExFreePool(frl);
+        Status = STATUS_SUCCESS;
     }
     
     return Status;
@@ -3033,9 +2657,7 @@
 }
 
 static NTSTATUS STDCALL fill_in_file_name_information(FILE_NAME_INFORMATION* fni, fcb* fcb, file_ref* fileref, LONG* length) {
-#ifdef _DEBUG
-    ULONG retlen = 0;
-#endif
+    ULONG reqlen;
     UNICODE_STRING fn;
     NTSTATUS Status;
     static WCHAR datasuf[] = {':','$','D','A','T','A',0};
@@ -3046,8 +2668,6 @@
         return STATUS_INVALID_PARAMETER;
     }
    
-    RtlZeroMemory(fni, sizeof(FILE_NAME_INFORMATION));
-    
     *length -= (LONG)offsetof(FILE_NAME_INFORMATION, FileName[0]);
     
     TRACE("maximum length is %u\n", *length);
@@ -3055,53 +2675,42 @@
     
     fni->FileName[0] = 0;
     
-    Status = fileref_get_filename(fileref, &fn, NULL);
-    if (!NT_SUCCESS(Status)) {
+    fn.Buffer = fni->FileName;
+    fn.Length = 0;
+    fn.MaximumLength = *length;
+    
+    Status = fileref_get_filename(fileref, &fn, NULL, &reqlen);
+    if (!NT_SUCCESS(Status) && Status != STATUS_BUFFER_OVERFLOW) {
         ERR("fileref_get_filename returned %08x\n", Status);
         return Status;
     }
     
-    if (*length >= (LONG)fn.Length) {
-        RtlCopyMemory(fni->FileName, fn.Buffer, fn.Length);
-#ifdef _DEBUG
-        retlen = fn.Length;
-#endif
-        *length -= fn.Length;
-    } else {
-        if (*length > 0) {
-            RtlCopyMemory(fni->FileName, fn.Buffer, *length);
-#ifdef _DEBUG
-            retlen = *length;
-#endif
-        }
-        *length = -1;
-    }
-    
-    fni->FileNameLength = fn.Length;
-    
     if (fcb->ads) {
-        if (*length >= (LONG)datasuflen) {
-            RtlCopyMemory(&fni->FileName[fn.Length / sizeof(WCHAR)], datasuf, datasuflen);
-#ifdef _DEBUG
-            retlen += datasuflen;
-#endif
-            *length -= datasuflen;
-        } else {
-            if (*length > 0) {
-                RtlCopyMemory(&fni->FileName[fn.Length / sizeof(WCHAR)], datasuf, *length);
-#ifdef _DEBUG
-                retlen += *length;
-#endif
+        if (Status == STATUS_BUFFER_OVERFLOW)
+            reqlen += datasuflen;
+        else {
+            if (fn.Length + datasuflen > fn.MaximumLength) {
+                RtlCopyMemory(&fn.Buffer[fn.Length / sizeof(WCHAR)], datasuf, fn.MaximumLength - fn.Length);
+                reqlen += datasuflen;
+                Status = STATUS_BUFFER_OVERFLOW;
+            } else {
+                RtlCopyMemory(&fn.Buffer[fn.Length / sizeof(WCHAR)], datasuf, datasuflen);
+                fn.Length += datasuflen;
             }
-            *length = -1;
         }
     }
     
-    ExFreePool(fn.Buffer);
-    
-    TRACE("%.*S\n", retlen / sizeof(WCHAR), fni->FileName);
+    if (Status == STATUS_BUFFER_OVERFLOW) {
+        *length = -1;
+        fni->FileNameLength = reqlen;
+        TRACE("%.*S (truncated)\n", fn.Length / sizeof(WCHAR), fn.Buffer);
+    } else {
+        *length -= fn.Length;
+        fni->FileNameLength = fn.Length;
+        TRACE("%.*S\n", fn.Length / sizeof(WCHAR), fn.Buffer);
+    }
 
-    return STATUS_SUCCESS;
+    return Status;
 }
 
 static NTSTATUS STDCALL fill_in_file_attribute_information(FILE_ATTRIBUTE_TAG_INFORMATION* ati, fcb* fcb, file_ref* fileref, PIRP Irp, LONG* length) {
@@ -3125,25 +2734,13 @@
     return STATUS_SUCCESS;
 }
 
-typedef struct {
-    UNICODE_STRING name;
-    UINT64 size;
-    BOOL ignore;
-    LIST_ENTRY list_entry;
-} stream_info;
-
-static NTSTATUS STDCALL fill_in_file_stream_information(FILE_STREAM_INFORMATION* fsi, file_ref* fileref, PIRP Irp, LONG* length) {
+static NTSTATUS STDCALL fill_in_file_stream_information(FILE_STREAM_INFORMATION* fsi, file_ref* fileref, LONG* length) {
     ULONG reqsize;
-    LIST_ENTRY streamlist, *le;
+    LIST_ENTRY* le;
     FILE_STREAM_INFORMATION *entry, *lastentry;
     NTSTATUS Status;
-    KEY searchkey;
-    traverse_ptr tp, next_tp;
-    BOOL b;
-    stream_info* si;
     
-    static WCHAR datasuf[] = {':','$','D','A','T','A',0};
-    static char xapref[] = "user.";
+    static WCHAR datasuf[] = L":$DATA";
     UNICODE_STRING suf;
     
     if (!fileref) {
